
// stand includes
#include <stdint.h>
#include <string.h>
// esp components includes
#include <esp_attr.h>
#include <freertos/FreeRTOS.h>
#include <freertos/task.h>
#include <esp_log.h>
// project includes
// this header or bsp_config.h proj_config.h
#include "init.h"
// #include <time.h>
// #include "freertos/FreeRTOS.h"
// #include "freertos/task.h"
// #include "esp_chip_info.h"
// #include "proj_config.h"
// #include "esp_mac.h"
// #include "util_common.h"
// #include "coreInit.h"
// #include "app_key.h"
// #include "clock.h"
// #include "esp_log.h"
// #include "gm_cloud.h"
// #include "esp_ota_ops.h"
// #include "upgrade.h"
// #include "app_sound.h"
// #include "app_motor.h"
// #include "app_gui.h"
// #include "app_gmm.h"
// #include "app_work.h"
// #include "app_timedWork.h"
// #include "app_err.h"
// #include "srv_log.h"
// #include "nvs.h"
// #include "mbedtls/md5.h"
// #include "cJSON.h"
// #include "uart.h"


#define MOD_TAG "INIT"


int init(void)
{
    // vTaskDelete(NULL);
    // return 0;
    int ret = 0;
    int wdt_inited = 0;

    extern init_desc_t _init_start;
    extern init_desc_t _init_end;

typedef struct {
    esp_err_t (*fn)(void);   /*!< Pointer to the startup function */
    uint32_t cores;     /*!< Bit map of cores where the function has to be called */
} esp_system_init_fn_t;

    extern esp_system_init_fn_t _esp_system_init_fn_array_start;
    extern esp_system_init_fn_t _esp_system_init_fn_array_end;
    extern esp_system_init_fn_t _rodata_end;

    init_desc_t *p;

    ESP_LOGE(MOD_TAG, "init running:%X-%X,%X-%X, %Xh %Xh",
                (unsigned)&_init_start, (unsigned)&_init_end,
                (unsigned)&_esp_system_init_fn_array_start, (unsigned)&_esp_system_init_fn_array_end,
                (unsigned)&_rodata_end, (unsigned)&_rodata_end);
    // while (1) {
    //     vTaskDelay(1);
    // }
    // init
    for (p = &_init_start; p < &_init_end; ++p) {
        // TODO 喂狗
        if (wdt_inited) {
        }
        // TODO 运行状态
        // 初始化
        if (p->init == NULL || (ret = p->init(p)) != 0) {
            // 停止工作
            ESP_LOGE(MOD_TAG, "mod[%s]:Failed[%d] to init[%Xh] !!!", p->name, ret, (unsigned)p->init);
            goto lable_err_reboot;
        }
        // 看门狗初始化了
        if (strcmp(p->name, "WDT") == 0) {
            // TODO 注册初始化
            wdt_inited = 1;
        }
    }

    // run
    for (p = &_init_start; p < &_init_end; ++p) {
        // TODO 喂狗
        // TODO 运行状态
        // 初始化
        if (p->thread != NULL) {
            ret = xTaskCreatePinnedToCore((void(*)(void*))p->thread, p->name, p->stack_size, p, p->priority, NULL, p->core);
            if (ret != pdPASS) {
                // 停止工作
                ESP_LOGE(MOD_TAG, "mod[%s]:Failed[%d] to run[%Xh]!!!", p->name, ret, (unsigned)p->thread);
                goto lable_err_reboot;
            }
        }
    }

    ESP_LOGE(MOD_TAG, "init over.");
    // TODO 反注册喂狗
    // wdtTaskUnReg(NULL);
    // 清理本线程
    vTaskDelete(NULL);
    return 0;

lable_err_reboot:
    vTaskDelay(10000/portTICK_PERIOD_MS);
    esp_restart();

    return -1;
}

int test_init1(init_desc_t *self)
{
    ESP_LOGE(MOD_TAG, "%s is running.", __FUNCTION__);

    return 0;
}
INIT_FN_EXPORT(init1, NULL, "5", test_init1, 0, 1000, 0, NULL)
